#include <v1model.p4>

// HEADERS AND TYPES ************************************************************

struct metadata_t {
}

struct header_t {
}

// INGRESS ************************************************************
// PARSER ************************************************************

parser MyIngressParser(packet_in pkt,
		       out header_t hdr,
		       inout metadata_t meta,
		       inout standard_metadata_t stm
		      ) {
    state start {
        transition accept;
    }
}

// CONTROL ************************************************************

control MyIngress(inout header_t hdr,
		  inout metadata_t meta,
		  inout standard_metadata_t stm
		 ) {

    action send(bit<9> port){
        stm.egress_port = port;
    }

    action drop() {
	mark_to_drop(stm);
        exit;
    }

    apply {        
	if (stm.ingress_port == 48) send(52);
	else if (stm.ingress_port == 52) send(48);
	else drop();
    }
}

control MyIngressDeparser(packet_out pkt,
			  in header_t hdr
			 ) {
    apply {
	pkt.emit(hdr);
    }
}

control EmptyChecksum(inout header_t hdr, inout metadata_t meta) {
    apply {}
}

control EmptyEgress(inout header_t hdr, inout metadata_t meta, inout standard_metadata_t stm) {
    apply {}
}

V1Switch(MyIngressParser(), EmptyChecksum(), MyIngress(), EmptyEgress(), EmptyChecksum(), MyIngressDeparser()) main;

